(* demo.sml: 
 * demonstration of interacting C code involving structure  *)

(* Finish the below before you do "sml demo.sml"
    C> gcc -mrtd -shared struct.c -o struct.dll
    C> ml-nlffigen -include ../libh.sml -DNLFFI struct.c

 * Note: Here "C>" means cmd.exe's prompt. 
   You can "set prompt=$n$g" to such a propmt, though it is useless. 

 * We'll show the transcript below.

cd C:\Users\saitohm\Documents\Code\garakuta\nlffi_st
C>dir

C:\Users\saitohm\Documents\Code\garakuta\nlffi_st ̃fBNg

ߘa3/08/20  20:33    <DIR>          .
ߘa3/08/20  20:33    <DIR>          ..
ߘa3/08/20  19:45    <DIR>          .cm
ߘa3/08/20  20:07            48,429 2020-08-20.log
ߘa3/08/20  20:33             1,667 demo.sml
ߘa3/08/20  19:40               760 libh.sml
ߘa3/08/20  19:55    <DIR>          NLFFI-Generated
ߘa3/08/20  19:44               304 struct.c
ߘa3/08/20  19:55            27,405 struct.dll
               5 ̃t@C              78,565 oCg
               4 ̃fBNg  727,934,922,752 oCg̋󂫗̈

C>gcc -mrtd -shared struct.c -o struct.dll
C>ml-nlffigen -include ../libh.sml -DNLFFI struct.c

C>dir NLFFI-Generated
C:\Users\saitohm\Documents\Code\garakuta\nlffi_st\NLFFI-Generated ̃fBNg

ߘa3/08/20  19:42    <DIR>          .
ߘa3/08/20  19:42    <DIR>          ..
ߘa3/08/20  19:42               376 callop-0.sml
ߘa3/08/20  19:42               741 f-set_number.sml
ߘa3/08/20  19:42               479 fptr-rtti-0.sml
ߘa3/08/20  19:42               484 nlffi-generated.cm
ߘa3/08/20  19:42               817 s-St.sml
ߘa3/08/20  19:42               504 st-St.sml
               6 ̃t@C               3,401 oCg
               2 ̃fBNg  728,134,926,336 oCg̋󂫗̈
*)
val it = CM.make "NLFFI-Generated/nlffi-generated.cm"
val it = CM.make "$c/c.cm";
val sizeofSt = Unsafe.cast S_St.size: int ;
(* val it = 12 : int  -- it's wrong!. It should be 16 *)

val obj = C.new' S_St.size ;
(* val obj = - : (S_St.tag C.su,?.X1) C.obj' *)

val it = F_set_number.f'(C.Ptr.|&! (C.rw' obj)) ;

val m_int = C.Get.sint' (S_St.f_m_int' obj) ;
(* val m_int = 5 : Int32.int *)

val m_double_ng  = C.Get.double' (S_St.f_m_double' obj) ;
(* val m_double_ng = 1.01595548785E~316 : real *) (* due to mis-alignment *)

val offset8 = Unsafe.cast( (Unsafe.cast obj: Word32.word) + 0w8 ): C.rw C.double_obj';
(* val offset8 = - : C.rw C.double_obj' *)
val m_double_ok = C.Get.double' offset8;
(* val m_double_ok = 5.5 : real *)
