structure Library = struct
    local
      val LIB = OS.Path.joinDirFile {dir = "./", file = "struct.dll"}
      fun handle_err (DynLinkage.DynLinkError s) =
        (print "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n"
        ;print("* Dyanmic linking failes: " ^ s ^ "\n")
        ;print "* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n"
        ;raise DynLinkage.DynLinkError s
        )
        val lh = DynLinkage.open_lib
           { name = LIB, global = true, lazy = true }
                    handle e => handle_err e

    in
        fun libh s = let
          val sh = DynLinkage.lib_symbol (lh, s) handle e => handle_err e
        in
          fn () => DynLinkage.addr sh
        end
    end
end
